%{?mingw_package_header}

%global bin_version 3.0.0
# first two digits of version
%define release_version %(echo %{version} | awk -F. '{print $1"."$2}')

# Only enable if using patches that touches configure.ac,
# Makefile.am or other build system related files
%define enable_autoreconf 0

Name:           mingw-gtk3
Version:        3.24.24
Release:        %mkrel 1
Summary:        MinGW Windows GTK+ library

License:        LGPLv2+
Group:          Development/Other
URL:            http://www.gtk.org
Source0:        https://download.gnome.org/sources/gtk+/%{release_version}/gtk+-%{version}.tar.xz
# wine gtk-query-immodules-3.0.exe | sed -e 's@Z:/usr/i686-w64-mingw32/sys-root/mingw@..@' -e 's@/usr/i686-w64-mingw32/sys-root/mingw@..@' > gtk.immodules
Source1:        gtk.immodules

# (tv) fix build on ia32 (missing GOBJECT_INTROSPECTION_CHECK definition):
BuildRequires:  pkgconfig(gobject-introspection-1.0)

BuildArch:      noarch

BuildRequires:  mingw32-filesystem >= 98
BuildRequires:  mingw64-filesystem >= 98
BuildRequires:  mingw32-gcc
BuildRequires:  mingw64-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw64-binutils

BuildRequires:  mingw32-atk
BuildRequires:  mingw64-atk
BuildRequires:  mingw32-cairo
BuildRequires:  mingw64-cairo
BuildRequires:  mingw32-gdk-pixbuf
BuildRequires:  mingw64-gdk-pixbuf
BuildRequires:  mingw32-gettext
BuildRequires:  mingw64-gettext
BuildRequires:  mingw32-glib2
BuildRequires:  mingw64-glib2
BuildRequires:  mingw32-libepoxy
BuildRequires:  mingw64-libepoxy
BuildRequires:  mingw32-win-iconv
BuildRequires:  mingw64-win-iconv
BuildRequires:  mingw32-pango
BuildRequires:  mingw64-pango
BuildRequires:  mingw32-pixman
BuildRequires:  mingw64-pixman
BuildRequires:  mingw32-zlib
BuildRequires:  mingw64-zlib

# Native one for msgfmt
BuildRequires:  gettext
# Native one for glib-genmarshal
BuildRequires:  pkgconfig(glib-2.0)
# Native one for gtk-update-icon-cache
BuildRequires:  gtk-update-icon-cache
# Native one for gdk-pixbuf-csource
BuildRequires:  libgdk_pixbuf2.0-devel
# Native one for /usr/bin/perl
BuildRequires:  perl

%if 0%{?enable_autoreconf}
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  pkgconfig(gobject-introspection-1.0)
BuildRequires:  libtool
%endif


%description
GTK+ is a multi-platform toolkit for creating graphical user
interfaces. Offering a complete set of widgets, GTK+ is suitable for
projects ranging from small one-off tools to complete application
suites.

This package contains the MinGW Windows cross compiled GTK+ 3 library.


%package -n mingw32-gtk3
Summary:        MinGW Windows GTK+ library
Requires:       mingw32-adwaita-icon-theme
# split out in a subpackage
Requires:       mingw32-gtk-update-icon-cache

%description -n mingw32-gtk3
GTK+ is a multi-platform toolkit for creating graphical user
interfaces. Offering a complete set of widgets, GTK+ is suitable for
projects ranging from small one-off tools to complete application
suites.

This package contains the MinGW Windows cross compiled GTK+ 3 library.


%package -n mingw32-gtk-update-icon-cache
Summary: Icon theme caching utility

%description -n mingw32-gtk-update-icon-cache
GTK+ can use the cache files created by gtk-update-icon-cache to avoid a lot of
system call and disk seek overhead when the application starts. Since the
format of the cache files allows them to be mmap()ed shared between multiple
applications, the overall memory consumption is reduced as well.

This package contains the MinGW Windows cross compiled gtk-update-icon-cache.


%package -n mingw64-gtk3
Summary:        MinGW Windows GTK+ library
Requires:       mingw64-adwaita-icon-theme
# split out in a subpackage
Requires:       mingw64-gtk-update-icon-cache

%description -n mingw64-gtk3
GTK+ is a multi-platform toolkit for creating graphical user
interfaces. Offering a complete set of widgets, GTK+ is suitable for
projects ranging from small one-off tools to complete application
suites.

This package contains the MinGW Windows cross compiled GTK+ 3 library.


%package -n mingw64-gtk-update-icon-cache
Summary: Icon theme caching utility

%description -n mingw64-gtk-update-icon-cache
GTK+ can use the cache files created by gtk-update-icon-cache to avoid a lot of
system call and disk seek overhead when the application starts. Since the
format of the cache files allows them to be mmap()ed shared between multiple
applications, the overall memory consumption is reduced as well.

This package contains the MinGW Windows cross compiled gtk-update-icon-cache.


%{?mingw_debug_package}


%prep
%setup -q -n gtk+-%{version}
%autopatch -p1
%if 0%{?enable_autoreconf}
autoreconf --install --force
%endif


%build
%mingw_configure \
  --disable-cups

%mingw_make %{?_smp_mflags} V=1 GLIB_COMPILE_RESOURCES=glib-compile-resources


%install
%mingw_make install DESTDIR=$RPM_BUILD_ROOT

rm -f $RPM_BUILD_ROOT/%{mingw32_libdir}/charset.alias
rm -f $RPM_BUILD_ROOT/%{mingw64_libdir}/charset.alias

# Remove manpages which duplicate those in Fedora native.
rm -rf $RPM_BUILD_ROOT%{mingw32_mandir}
rm -rf $RPM_BUILD_ROOT%{mingw64_mandir}

# Remove documentation too.
rm -rf $RPM_BUILD_ROOT%{mingw32_datadir}/gtk-doc
rm -rf $RPM_BUILD_ROOT%{mingw64_datadir}/gtk-doc

# Remove unneeded files
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/*.def
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/*.def

# Remove files used only for tests.
rm -f $RPM_BUILD_ROOT%{mingw32_bindir}/libgtkreftestprivate-0.dll
rm -f $RPM_BUILD_ROOT%{mingw64_bindir}/libgtkreftestprivate-0.dll
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/libgtkreftestprivate.dll.a
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/libgtkreftestprivate.dll.a

rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/*.dll.a
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/*.dll.a
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/*.la
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/*.la

# Remove desktop files and corresponding icons as they aren't useful for win32
rm -f $RPM_BUILD_ROOT%{mingw32_datadir}/applications/*.desktop
rm -f $RPM_BUILD_ROOT%{mingw64_datadir}/applications/*.desktop
rm -f $RPM_BUILD_ROOT%{mingw32_datadir}/icons/hicolor/*/apps/*.png
rm -f $RPM_BUILD_ROOT%{mingw64_datadir}/icons/hicolor/*/apps/*.png

# Install the gtk.immodules file
mkdir -p $RPM_BUILD_ROOT%{mingw32_sysconfdir}/gtk-3.0/
mkdir -p $RPM_BUILD_ROOT%{mingw64_sysconfdir}/gtk-3.0/
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{mingw32_sysconfdir}/gtk-3.0/
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{mingw64_sysconfdir}/gtk-3.0/

%mingw_find_lang %{name} --all-name


%postun -n mingw32-gtk3
if [ $1 -eq 0 ] ; then
    /usr/bin/glib-compile-schemas %{mingw32_datadir}/glib-2.0/schemas &> /dev/null || :
fi

%posttrans -n mingw32-gtk3
/usr/bin/glib-compile-schemas %{mingw32_datadir}/glib-2.0/schemas &> /dev/null || :

%postun -n mingw64-gtk3
if [ $1 -eq 0 ] ; then
    /usr/bin/glib-compile-schemas %{mingw64_datadir}/glib-2.0/schemas &> /dev/null || :
fi

%posttrans -n mingw64-gtk3
/usr/bin/glib-compile-schemas %{mingw64_datadir}/glib-2.0/schemas &> /dev/null || :


%files -n mingw32-gtk3 -f mingw32-%{name}.lang
%license COPYING
%{mingw32_bindir}/gtk3-demo-application.exe
%{mingw32_bindir}/gtk3-demo.exe
%{mingw32_bindir}/gtk3-icon-browser.exe
%{mingw32_bindir}/gtk3-widget-factory.exe
%{mingw32_bindir}/gtk-builder-tool.exe
%{mingw32_bindir}/gtk-encode-symbolic-svg.exe
%{mingw32_bindir}/gtk-launch.exe
%{mingw32_bindir}/gtk-query-immodules-3.0.exe
%{mingw32_bindir}/gtk-query-settings.exe
%{mingw32_bindir}/libgdk-3-0.dll
%{mingw32_bindir}/libgailutil-3-0.dll
%{mingw32_bindir}/libgtk-3-0.dll
%{mingw32_sysconfdir}/gtk-3.0/
%{mingw32_includedir}/gtk-3.0/
%{mingw32_includedir}/gail-3.0/
%dir %{mingw32_libdir}/gtk-3.0
%dir %{mingw32_libdir}/gtk-3.0/%{bin_version}
%dir %{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-am-et.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-cedilla.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-cyrillic-translit.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-ime.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-inuktitut.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-ipa.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-multipress.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-thai.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-ti-er.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-ti-et.dll
%{mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-viqr.dll
%{mingw32_libdir}/libgailutil-3.dll.a
%{mingw32_libdir}/libgdk-3.dll.a
%{mingw32_libdir}/libgtk-3.dll.a
%{mingw32_libdir}/pkgconfig/gail-3.0.pc
%{mingw32_libdir}/pkgconfig/gdk-3.0.pc
%{mingw32_libdir}/pkgconfig/gdk-win32-3.0.pc
%{mingw32_libdir}/pkgconfig/gtk+-3.0.pc
%{mingw32_libdir}/pkgconfig/gtk+-win32-3.0.pc
%{mingw32_datadir}/aclocal/gtk-3.0.m4
%{mingw32_datadir}/gettext/
%{mingw32_datadir}/glib-2.0/schemas/org.gtk.exampleapp.gschema.xml
%{mingw32_datadir}/glib-2.0/schemas/org.gtk.Demo.gschema.xml
%{mingw32_datadir}/glib-2.0/schemas/org.gtk.Settings.ColorChooser.gschema.xml
%{mingw32_datadir}/glib-2.0/schemas/org.gtk.Settings.Debug.gschema.xml
%{mingw32_datadir}/glib-2.0/schemas/org.gtk.Settings.EmojiChooser.gschema.xml
%{mingw32_datadir}/glib-2.0/schemas/org.gtk.Settings.FileChooser.gschema.xml
%{mingw32_datadir}/gtk-3.0/
%{mingw32_datadir}/themes/*

%files -n mingw32-gtk-update-icon-cache
%license COPYING
%{mingw32_bindir}/gtk-update-icon-cache.exe

%files -n mingw64-gtk3 -f mingw64-%{name}.lang
%license COPYING
%{mingw64_bindir}/gtk3-demo-application.exe
%{mingw64_bindir}/gtk3-demo.exe
%{mingw64_bindir}/gtk3-icon-browser.exe
%{mingw64_bindir}/gtk3-widget-factory.exe
%{mingw64_bindir}/gtk-builder-tool.exe
%{mingw64_bindir}/gtk-encode-symbolic-svg.exe
%{mingw64_bindir}/gtk-launch.exe
%{mingw64_bindir}/gtk-query-immodules-3.0.exe
%{mingw64_bindir}/gtk-query-settings.exe
%{mingw64_bindir}/libgdk-3-0.dll
%{mingw64_bindir}/libgailutil-3-0.dll
%{mingw64_bindir}/libgtk-3-0.dll
%{mingw64_sysconfdir}/gtk-3.0/
%{mingw64_includedir}/gtk-3.0/
%{mingw64_includedir}/gail-3.0/
%dir %{mingw64_libdir}/gtk-3.0
%dir %{mingw64_libdir}/gtk-3.0/%{bin_version}
%dir %{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-am-et.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-cedilla.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-cyrillic-translit.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-ime.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-inuktitut.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-ipa.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-multipress.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-thai.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-ti-er.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-ti-et.dll
%{mingw64_libdir}/gtk-3.0/%{bin_version}/immodules/im-viqr.dll
%{mingw64_libdir}/libgailutil-3.dll.a
%{mingw64_libdir}/libgdk-3.dll.a
%{mingw64_libdir}/libgtk-3.dll.a
%{mingw64_libdir}/pkgconfig/gail-3.0.pc
%{mingw64_libdir}/pkgconfig/gdk-3.0.pc
%{mingw64_libdir}/pkgconfig/gdk-win32-3.0.pc
%{mingw64_libdir}/pkgconfig/gtk+-3.0.pc
%{mingw64_libdir}/pkgconfig/gtk+-win32-3.0.pc
%{mingw64_datadir}/aclocal/gtk-3.0.m4
%{mingw64_datadir}/gettext/
%{mingw64_datadir}/glib-2.0/schemas/org.gtk.exampleapp.gschema.xml
%{mingw64_datadir}/glib-2.0/schemas/org.gtk.Demo.gschema.xml
%{mingw64_datadir}/glib-2.0/schemas/org.gtk.Settings.ColorChooser.gschema.xml
%{mingw64_datadir}/glib-2.0/schemas/org.gtk.Settings.Debug.gschema.xml
%{mingw64_datadir}/glib-2.0/schemas/org.gtk.Settings.EmojiChooser.gschema.xml
%{mingw64_datadir}/glib-2.0/schemas/org.gtk.Settings.FileChooser.gschema.xml
%{mingw64_datadir}/gtk-3.0/
%{mingw64_datadir}/themes/*

%files -n mingw64-gtk-update-icon-cache
%license COPYING
%{mingw64_bindir}/gtk-update-icon-cache.exe




%changelog
* Sun Dec 06 2020 ovitters <ovitters> 3.24.24-1.mga8
+ Revision: 1653253
- new version 3.24.24

* Sat Sep 26 2020 tv <tv> 3.24.23-2.mga8
+ Revision: 1630470
- rebuild for new mingw stack

* Fri Sep 04 2020 ovitters <ovitters> 3.24.23-1.mga8
+ Revision: 1621710
- new version 3.24.23

* Mon Aug 10 2020 ovitters <ovitters> 3.24.22-1.mga8
+ Revision: 1613085
- new version 3.24.22

* Sun Jun 28 2020 ovitters <ovitters> 3.24.21-1.mga8
+ Revision: 1600245
- new version 3.24.21

* Mon Apr 27 2020 ovitters <ovitters> 3.24.20-1.mga8
+ Revision: 1572468
- new version 3.24.20

* Fri Apr 10 2020 ovitters <ovitters> 3.24.18-1.mga8
+ Revision: 1565957
- new version 3.24.18

* Fri Apr 03 2020 ovitters <ovitters> 3.24.17-1.mga8
+ Revision: 1564189
- new version 3.24.17

* Fri Mar 27 2020 ovitters <ovitters> 3.24.16-1.mga8
+ Revision: 1561246
- new version 3.24.16
- new version 3.24.15

* Tue Feb 18 2020 umeabot <umeabot> 3.24.14-2.mga8
+ Revision: 1538883
- Mageia 8 Mass Rebuild

* Mon Feb 17 2020 ovitters <ovitters> 3.24.14-1.mga8
+ Revision: 1537035
- new version 3.24.14

* Wed Nov 27 2019 ovitters <ovitters> 3.24.13-1.mga8
+ Revision: 1463216
- new version 3.24.13

* Fri Oct 04 2019 ovitters <ovitters> 3.24.12-1.mga8
+ Revision: 1449267
- new version 3.24.12

* Wed Sep 04 2019 ovitters <ovitters> 3.24.11-1.mga8
+ Revision: 1436924
- new version 3.24.11

* Fri Aug 30 2019 daviddavid <daviddavid> 3.24.10-1.mga8
+ Revision: 1435275
- new version: 3.24.10

* Wed Sep 19 2018 umeabot <umeabot> 3.20.10-2.mga7
+ Revision: 1264277
- Mageia 7 Mass Rebuild

* Tue Feb 21 2017 ovitters <ovitters> 3.20.10-1.mga6
+ Revision: 1087290
- new version 3.20.10

* Mon May 23 2016 ovitters <ovitters> 3.20.6-1.mga6
+ Revision: 1018038
- new version 3.20.6

* Thu May 19 2016 ovitters <ovitters> 3.20.5-1.mga6
+ Revision: 1016997
- new version 3.20.5

* Mon May 09 2016 ovitters <ovitters> 3.20.4-1.mga6
+ Revision: 1011633
- new version 3.20.4

* Tue Apr 12 2016 ovitters <ovitters> 3.20.3-1.mga6
+ Revision: 1000699
- new version 3.20.3

* Wed Apr 06 2016 tv <tv> 3.20.2-1.mga6
+ Revision: 998999
- BR gobject-introspection-devel for missing GOBJECT_INTROSPECTION_CHECK definition on ia32
- adjust file list
- patch 10: pretend mingw does not have file locking
- resync with FC
- "fix" underlinking
- new release
- new release

* Thu Feb 18 2016 umeabot <umeabot> 3.10.9-2.mga6
+ Revision: 965622
- Mageia 6 Mass Rebuild

* Sat Jun 20 2015 ovitters <ovitters> 3.10.9-1.mga6
+ Revision: 836391
- new version 3.10.9
- dropped merged patch 2

* Wed Oct 15 2014 umeabot <umeabot> 3.10.7-3.mga5
+ Revision: 745908
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 3.10.7-2.mga5
+ Revision: 682451
- Mageia 5 Mass Rebuild

* Tue Feb 04 2014 ovitters <ovitters> 3.10.7-1.mga5
+ Revision: 582666
- new version 3.10.7

* Sun Oct 27 2013 neoclust <neoclust> 3.10.0-1.mga4
+ Revision: 547225
- imported package mingw-gtk3

